<?php

/**
 * noDarkmode Plugin
 *
 * @author  reDim GmbH | Elias Ritter
 * @license GNU General Public License 2.0 or later, see https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
 * @since   version 1.0
 */

\defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;
use Joomla\DI\Container;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\Event\DispatcherInterface;
use Joomla\DI\ServiceProviderInterface;
use Joomla\CMS\Extension\PluginInterface;
use Joomla\Plugin\System\nodarkmode\Extension\nodarkmode;

return new class () implements ServiceProviderInterface {
	/**
	 * Registers the service provider with a DI container.
	 *
	 * @param   Container  $container  The DI container.
	 *
	 * @return  void
	 *
	 * @since   1.0
	 */
	public function register(Container $container): void
	{
		$container->set(PluginInterface::class, function (Container $container) {
			$plugin = new nodarkmode(
				$container->get(DispatcherInterface::class),
				Uri::getInstance(),
				(array) PluginHelper::getPlugin('system', 'nodarkmode')
			);

			$plugin->setApplication(Factory::getApplication());

			return $plugin;
		});
	}
};