<?php

use Joomla\CMS\Factory;
use Joomla\Filesystem\File;
use Joomla\CMS\Installer\InstallerScript;
use Joomla\Plugin\System\nodarkmode\Extension\nodarkmode;

defined('_JEXEC') or die;

/**
 * noDarkmode Uninstaller / Cleaner
 *
 * @author  reDim GmbH | Elias Ritter
 * @license GNU General Public License 2.0 or later, see https://www.gnu.org/licenses/old-licenses/gpl-2.0.en.html
 * @since   version 1.0
 */
class plgSystemnodarkmodeInstallerScript extends InstallerScript
{
	public function uninstall()
	{
		if (!class_exists('nodarkmode'))
		{
			require_once __DIR__ . '/Extension/nodarkmode.php';
		}

		$this->cleanFiles();
		$this->unsetConfigurationCookie();
	}

	/**
	 * Collects and deletes the remaining Cache-files
	 *
	 * @since version 1.0
	 */
	private function cleanFiles()
	{
		$files = nodarkmode::getImportList();

		foreach ($files as $items)
		{
			if (!is_readable($items->newfile))
			{
				return;
			}

			File::delete($items->newfile);
		}
	}

	/**
	 * Unsets the remaining Configuration Cookie
	 *
	 * @throws Exception
	 * @since version 1.0
	 */
	private function unsetConfigurationCookie()
	{
		$name = nodarkmode::COOKIE['name'];
		$app  = Factory::getApplication();

		if ($app->input->cookie->get($name))
		{
			setcookie($name, '', -1);
		}
	}
}